Index: branches/vs-enhencements/src/lib/math/quaternion.h
===================================================================
--- branches/vs-enhencements/src/lib/math/quaternion.h	(revision 10639)
+++ branches/vs-enhencements/src/lib/math/quaternion.h	(revision 10640)
@@ -50,7 +50,7 @@
 
     /** @param q: the Quaternion to compare with this one. @returns true if the Quaternions are the same, false otherwise */
-  inline bool operator== (const Quaternion& q) const { return (unlikely(this->v==q.v&&this->w==q.w))?true:false; };
+    inline bool operator== (const Quaternion& q) const { return (unlikely(this->v==q.v&&this->w==q.w))?true:false; };
     /** @param q: the Quaternion to compare with this one. @returns true if the Quaternions are the same, false otherwise */
-  inline bool operator!= (const Quaternion& q) const { return (unlikely(this->v!=q.v||this->w!=q.w))?true:false; };
+    inline bool operator!= (const Quaternion& q) const { return (unlikely(this->v!=q.v||this->w!=q.w))?true:false; };
     /** @param f: a real value @return a Quaternion containing the quotient */
     inline Quaternion operator/ (const float& f) const { return (unlikely(f==0.0)) ? Quaternion() : Quaternion(this->v/f, this->w/f); };
Index: branches/vs-enhencements/src/util/track/track.cc
===================================================================
--- branches/vs-enhencements/src/util/track/track.cc	(revision 10639)
+++ branches/vs-enhencements/src/util/track/track.cc	(revision 10640)
@@ -65,5 +65,8 @@
   this->duration = 20;
   this->endTime = 20;
-  this->width = 10;
+  this->width = 24;
+  this->height = 18;
+  this->depth = 200;
+  this->stretch = 4;
   this->curve = new BezierCurve();
   this->trackNode = new PNode(PNode::getNullParent(), PNODE_ALL);
@@ -331,2 +334,55 @@
     glPopMatrix();
 }
+
+void Track::drawBox() const
+{
+    glMatrixMode(GL_MODELVIEW);
+    glPushMatrix();
+
+    glPushAttrib(GL_ENABLE_BIT);
+
+    glDisable(GL_LIGHTING);
+    glDisable(GL_TEXTURE_2D);
+    glDisable(GL_BLEND);
+    glLineWidth(2.0);
+
+    glTranslatef (trackNode->getAbsCoor ().x,
+                  trackNode->getAbsCoor ().y,
+                  trackNode->getAbsCoor ().z);
+    Vector tmpRot = trackNode->getAbsDir().getSpacialAxis();
+    glRotatef (trackNode->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
+
+
+    glColor3f(1.0, 1.0, 0.0);
+    glBegin(GL_LINE_STRIP);
+      glVertex3f(0, height, width);
+      glVertex3f(0, -height, width);
+      glVertex3f(0, -height, -width);
+      glVertex3f(0, height, -width);
+      glVertex3f(0, height, width);
+    glEnd();
+
+    glBegin(GL_LINE_STRIP);
+      glVertex3f(depth, height * stretch, width * stretch);
+      glVertex3f(depth, -height * stretch, width * stretch);
+      glVertex3f(depth, -height * stretch, -width * stretch);
+      glVertex3f(depth, height * stretch, -width * stretch);
+      glVertex3f(depth, height * stretch, width * stretch);
+    glEnd();
+
+    glBegin(GL_LINE_STRIP);
+      glVertex3f(depth, height * stretch, width * stretch);
+      glVertex3f(0, height, width);
+      glVertex3f(0, -height, width);
+      glVertex3f(depth, -height * stretch, width * stretch);
+    glEnd();
+
+    glBegin(GL_LINE_STRIP);
+      glVertex3f(depth, height * stretch, -width * stretch);
+      glVertex3f(0, height, -width);
+      glVertex3f(0, -height, -width);
+      glVertex3f(depth, -height * stretch, -width * stretch);
+    glEnd();
+
+    glPopMatrix();
+}
Index: branches/vs-enhencements/src/util/track/track.h
===================================================================
--- branches/vs-enhencements/src/util/track/track.h	(revision 10639)
+++ branches/vs-enhencements/src/util/track/track.h	(revision 10640)
@@ -37,4 +37,5 @@
 
    void drawGraph(float dt = 0.01) const;
+   void drawBox() const;
 
    //float                 startingTime;         //!< The time at which this Track begins.
@@ -43,4 +44,7 @@
    float                 endTime;              //!< The time at which this Track ends.
    float                 width;                //!< Th width of the Path. This tells the Player(s), how far he(they) can go to the left/right.
+   float                 height;
+   float                 depth;
+   float                 stretch;
 
    int                   nodeCount;            //!< The count of points this Track has.
Index: branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc	(revision 10639)
+++ branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc	(revision 10640)
@@ -246,5 +246,5 @@
 
 
- this->loadModel("models/spaceships/human_spaceship_fighter.obj", .25);
+  this->loadModel("models/spaceships/fighter_redesign9.obj");
   //this->setVisibiliy(false);
 
@@ -494,4 +494,5 @@
   if( this->entityTrack != NULL && this->isDrawTrack())
     this->entityTrack->drawGraph();
+  this->entityTrack->drawBox();
 
   WorldEntity::draw();