Index: branches/vs-enhencements/src/world_entities/projectiles/plasma_pulse.cc
===================================================================
--- branches/vs-enhencements/src/world_entities/projectiles/plasma_pulse.cc	(revision 10657)
+++ branches/vs-enhencements/src/world_entities/projectiles/plasma_pulse.cc	(revision 10659)
@@ -47,8 +47,15 @@
   this->grid->setVisibility(false);
   this->grid->setPulse();
-
   this->grid->setTexture( "textures/plasma.png");
-
-  this->grid->toList(OM_ENVIRON); 
+  this->grid->toList(OM_ENVIRON);
+/*
+  this->blink = new Blink();
+  this->grid->setParent(this);
+  this->grid->setVisibility(false);
+  this->blink->setSize(1.0 );
+  this->blink->setPeriod(.4);
+  this->blink->setColor(10, 250, 150);
+  this->blink->loadBlinkSequence( "66678998766" );
+  this->blink->toList(OM_ENVIRON);*/
 }
 
@@ -61,4 +68,5 @@
 {
   this->grid->toList(OM_DEAD);
+//   this->blink->toList(OM_DEAD);
 }
 
@@ -69,4 +77,5 @@
   this->toList(OM_ENVIRON);
   this->grid->setVisibility(true);
+//   this->blink->setVisibility(true);
 
   this->setPhysDamage(10);
@@ -81,4 +90,5 @@
 
   this->grid->setVisibility(false);
+//   this->blink->setVisibility(false);
   this->lifeCycle = 0.0;
   this->toList(OM_NULL);
@@ -131,4 +141,5 @@
     glAlphaFunc( GL_GEQUAL, .5);
     this->grid->draw();
+//     this->blink->draw();
   glPopMatrix();
 
Index: branches/vs-enhencements/src/world_entities/projectiles/plasma_pulse.h
===================================================================
--- branches/vs-enhencements/src/world_entities/projectiles/plasma_pulse.h	(revision 10657)
+++ branches/vs-enhencements/src/world_entities/projectiles/plasma_pulse.h	(revision 10659)
@@ -9,4 +9,5 @@
 #include "projectile.h"
 #include "effects/billboard.h"
+#include "effects/blink.h"
 
 class Vector;
@@ -33,4 +34,5 @@
     static FastFactory*               fastFactory;
     Billboard*                        grid;
+//     Blink*                            blink;
 };
 
Index: branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc	(revision 10657)
+++ branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc	(revision 10659)
@@ -218,13 +218,5 @@
 
 
-//   this->weaponMan.addWeapon( acid0, 3, 0);
-//   this->weaponMan.addWeapon( acid1, 3, 1);
-
-
   this->secWeaponMan.addWeapon( cannon, 0, 2);
-//   this->secWeaponMan.addWeapon( spike, 1, 3);
-//   this->secWeaponMan.addWeapon( acid0, 2, 2);
-//   this->secWeaponMan.addWeapon( acid1, 2, 3);
-
 
   this->weaponMan.changeWeaponConfig(3);
@@ -232,39 +224,41 @@
 
 
-//   curWeaponPrimary    = 3;
-//   curWeaponSecondary  = 0;
-
   Playable::weaponConfigChanged();
 
-  reactorOutput     = 10;
-
-  weaponEnergyRegen = 10;       // 10 einheiten pro Sekunde
-  engineSpeedBase   = 15;
-  shieldRegen       = 2;
-
+//   reactorOutput     = 10;
+  setReactor(10);
+//   weaponEnergyRegen = 10;       // 10 einheiten pro Sekunde
+  setWeapon(10);
+//   engineSpeedBase   = 15;
+  setEngine(15);
+//   shieldRegen       = 2;
+/*
   shieldEnergyShare = 0.3;
   weaponEnergyShare = 0.3;
-  engineEnergyShare = 0.4;
-
+  engineEnergyShare = 0.4;*/
+  setEnergyShare(.3,.3,.4);
+/*
   shieldCur         = 100;
   shieldMax         = 100;
-  shieldTH          = .2 * shieldMax;   // shield power must be 20% before shield kicks in again
-
+  shieldTH          = .2 * shieldMax;   // shield power must be 20% before shield kicks in again*/
+  setShield(100, 100, .2, 2);
+/*
   this->setHealth( 100);
-  this->setHealthMax( 100);
-
+  this->setHealthMax( 100);*/
+  setArmor(100, 100);
+/*
   electronicCur = 50;
   electronicMax = 50;
   electronicRegen   = 3;
-  electronicTH      = .7 * electronicMax; // 30% of eDamage can be handled by the ship
-
-
-  this->loadModel("models/spaceships/fighter_redesign9.obj");
+  electronicTH      = .7 * electronicMax; // 30% of eDamage can be handled by the ship*/
+  setElectronic(50, 50, .7, 3.0);
+
+//   this->loadModel("models/spaceships/fighter_redesign9.obj");
   //this->setVisibiliy(false);
 
   bForward = bBackward = bLeft = bRight = bAscend = bDescend = bRollL = bRollR = bFire = bSecFire = false;
 
-  this->setHealthMax(shieldMax);
-  this->setHealth(shieldCur);
+//   this->setHealthMax(shieldMax);
+//   this->setHealth(shieldCur);
 
   this->travelNode = new PNode();
@@ -405,5 +399,5 @@
 //   this->trailL->setTexture( "textures/engine.png");
 //
-//   this->trailR = new Trail( 5, 10, .2, this);
+//   this->trailR = new ( 5, 10, .2, this);
 //   this->trailR->setTexture( "textures/engine.png");
 
@@ -437,4 +431,13 @@
 
   State::getCamera()->setViewMode(Camera::ViewTop);
+
+  LoadParam(root, "reactor", this, SpaceShip, setReactor);
+  LoadParam(root, "shield", this, SpaceShip, setShield);
+  LoadParam(root, "armor", this, SpaceShip, setArmor);
+  LoadParam(root, "electronic", this, SpaceShip, setElectronic);
+  LoadParam(root, "engine", this, SpaceShip, setEngine);
+  LoadParam(root, "energyshare", this, SpaceShip, setEnergyShare);
+  LoadParam(root, "weapon", this, SpaceShip, setWeapon);
+
 }
 
Index: branches/vs-enhencements/src/world_entities/space_ships/space_ship.h
===================================================================
--- branches/vs-enhencements/src/world_entities/space_ships/space_ship.h	(revision 10657)
+++ branches/vs-enhencements/src/world_entities/space_ships/space_ship.h	(revision 10659)
@@ -63,4 +63,22 @@
     inline WeaponManager& getWeaponManagerSecondary() { return this->secWeaponMan; };
 
+    inline void setReactor(float output) {this->reactorOutput = output; };
+    inline void setShield(float cur, float max, float th, float regen)
+        { this->shieldCur = cur; this->shieldMax = max; this->shieldTH = th; this->shieldRegen = regen;};
+    inline void setArmor(float cur, float max) { this->armorCur = cur; this->armorMax = max; updateHealth(); };
+    inline void setElectronic(float cur, float max, float th, float regen)
+        { this->electronicCur = cur; this->electronicMax = max; this->electronicTH = th; this->electronicRegen = regen; };
+    inline void setEngine( float speedBase) {this->engineSpeedBase = speedBase; };
+    inline void setEnergyShare(float shield, float weapon, float engine)
+        { float tmp = shield + weapon + engine; if (unlikely (tmp > 1)) { tmp = 1/tmp; }
+          // dirty safty hack, prevents total share being bigger than 1!!
+          this->shieldEnergyShare = shield * tmp;
+          this->weaponEnergyShare = weapon * tmp;
+          this->engineEnergyShare = engine * tmp; };
+    inline void setWeapon(float regen) { this->weaponEnergyRegen = regen; };
+
+    //!< Resynchonizes armor with health in WE!!
+    inline void updateHealth() { this->setHealth(this->armorCur); this->setHealthMax(this->armorMax); };
+
     //Functions for GUI
     inline float getShieldCur() { return this->shieldCur; };        //!< returns current shield value
@@ -86,5 +104,5 @@
     virtual void movement (float dt);
 
-    //
+
 
     void nextWeaponConfig();
@@ -92,5 +110,5 @@
 
     virtual void hit(float damage, WorldEntity* killer);
-    
+
     void                  setCameraDistance(float dist);
 
@@ -147,5 +165,5 @@
 
     float       reactorOutput;      //!< reactor output 
-    float       reactorCapacity;    //!< reactor capacity
+//    float       reactorCapacity;    //!< reactor capacity
 
     int         curWeaponPrimary;   //!< current primary weapon config 
@@ -208,9 +226,9 @@
 
     byte                  oldMask;            //!< used for synchronisation
-
+/*
     Trail*                trail;              //!< Burst trail
     Trail*                trailL;              //!< Burst trail
     Trail*                trailR;              //!< Burst trail
-
+*/
 
 };