Index: code/branches/fabienHS15/data/levels/templates/HeavyCruiser.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/HeavyCruiser.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/HeavyCruiser.oxt	(revision 10814)
@@ -19,6 +19,6 @@
    maxshieldhealth     = 50
    shieldabsorption    = 0.8
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 300
Index: code/branches/fabienHS15/data/levels/templates/HeavyCruiserBody.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/HeavyCruiserBody.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/HeavyCruiserBody.oxt	(revision 10814)
@@ -17,6 +17,6 @@
    maxshieldhealth     = 500
    shieldabsorption    = 0.8
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 300
Index: code/branches/fabienHS15/data/levels/templates/ModularSpaceShipTest.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/ModularSpaceShipTest.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/ModularSpaceShipTest.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 50
    shieldabsorption    = 0.8
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 100
Index: code/branches/fabienHS15/data/levels/templates/bigship.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/bigship.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/bigship.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 50
    shieldabsorption    = 0.8
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 30
Index: code/branches/fabienHS15/data/levels/templates/enemyInvader.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/enemyInvader.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/enemyInvader.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 10
    shieldabsorption    = 0.9
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 150
@@ -77,6 +77,6 @@
    maxshieldhealth     = 20
    shieldabsorption    = 0.9
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 150
Index: code/branches/fabienHS15/data/levels/templates/spaceshipAssff.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipAssff.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipAssff.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 50
    shieldabsorption    = 0.8
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 100
Index: code/branches/fabienHS15/data/levels/templates/spaceshipAssff2.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipAssff2.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipAssff2.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 150
    shieldabsorption    = 0.95
-   reloadrate          = 5
-   reloadwaittime      = 0.5
+   shieldrechargerate  = 5
+   shieldrechargewaittime = 0.5
 
    primaryThrust     = 100
Index: code/branches/fabienHS15/data/levels/templates/spaceshipCollateralDamage.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipCollateralDamage.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipCollateralDamage.oxt	(revision 10814)
@@ -16,6 +16,6 @@
    maxshieldhealth     = 50
    shieldabsorption    = 0.8
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 100
Index: code/branches/fabienHS15/data/levels/templates/spaceshipDodgeRace.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipDodgeRace.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipDodgeRace.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 20
    shieldabsorption    = 0.1
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 150
Index: code/branches/fabienHS15/data/levels/templates/spaceshipEscort.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipEscort.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipEscort.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 60
    shieldabsorption    = 0.9
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 150
Index: code/branches/fabienHS15/data/levels/templates/spaceshipFS15.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipFS15.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipFS15.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 800
    shieldabsorption    = 0.8
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 40
Index: code/branches/fabienHS15/data/levels/templates/spaceshipGhost.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipGhost.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipGhost.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 150
    shieldabsorption    = 0.9
-   reloadrate          = 3
-   reloadwaittime      = 0.0
+   shieldrechargerate  = 3
+   shieldrechargewaittime = 0.0
 
    primaryThrust     = 600
Index: code/branches/fabienHS15/data/levels/templates/spaceshipHeartAttack.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipHeartAttack.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipHeartAttack.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 800
    shieldabsorption    = 0.8
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 40
Index: code/branches/fabienHS15/data/levels/templates/spaceshipInvader.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipInvader.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipInvader.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 60
    shieldabsorption    = 0.9
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 150
Index: code/branches/fabienHS15/data/levels/templates/spaceshipPirate.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipPirate.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipPirate.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 40
    shieldabsorption    = 0.6
-   reloadrate          = 2
-   reloadwaittime      = 0.5
+   shieldrechargerate  = 2
+   shieldrechargewaittime = 0.5
 
    primaryThrust     = 100
Index: code/branches/fabienHS15/data/levels/templates/spaceshipRace.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipRace.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipRace.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 50
    shieldabsorption    = 0.8
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 100
Index: code/branches/fabienHS15/data/levels/templates/spaceshipRing.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipRing.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipRing.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 60
    shieldabsorption    = 0.9
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 150
Index: code/branches/fabienHS15/data/levels/templates/spaceshipSpacecruiser.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipSpacecruiser.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipSpacecruiser.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 90
    shieldabsorption    = 0.9
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 90
Index: code/branches/fabienHS15/data/levels/templates/spaceshipSwallow.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipSwallow.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipSwallow.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 80
    shieldabsorption    = 0.75
-   reloadrate          = 1.5
-   reloadwaittime      = 0.2
+   shieldrechargerate  = 1.5
+   shieldrechargewaittime = 0.2
 
    primaryThrust     = 600;
Index: code/branches/fabienHS15/data/levels/templates/spaceshipTurret.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/spaceshipTurret.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/spaceshipTurret.oxt	(revision 10814)
@@ -15,6 +15,6 @@
    maxshieldhealth     = 50
    shieldabsorption    = 0.8
-   reloadrate          = 1
-   reloadwaittime      = 1
+   shieldrechargerate  = 1
+   shieldrechargewaittime = 1
 
    primaryThrust     = 100
Index: code/branches/fabienHS15/data/levels/templates/towerdefensetower.oxt
===================================================================
--- code/branches/fabienHS15/data/levels/templates/towerdefensetower.oxt	(revision 10791)
+++ code/branches/fabienHS15/data/levels/templates/towerdefensetower.oxt	(revision 10814)
@@ -4,6 +4,6 @@
 
    	explosionchunks        = 6
-	reloadrate=10 
-	reloadwaittime=5 
+	shieldrechargerate=10 
+	shieldrechargewaittime=5 
 	collisionType="none" 
 	pitch="0" 