Index: code/branches/cpp11_v2/src/modules/jump/Jump.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/Jump.cc	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/Jump.cc	(revision 10817)
@@ -98,5 +98,5 @@
                 if (screenShiftSinceLastUpdate_ > center_->getSectionLength())
                 {
-                    if (sectionNumber_ > 2 && sectionNumber_%4 == 0 && rand()%2 == 0 && figure_->propellerActive_ == false && figure_->rocketActive_ == false && addAdventure(adventureNumber_) == true)
+                    if (sectionNumber_ > 2 && sectionNumber_%4 == 0 && rand()%2 == 0 && figure_->propellerActive_ == nullptr && figure_->rocketActive_ == nullptr && addAdventure(adventureNumber_) == true)
                     {
                         screenShiftSinceLastUpdate_ -= 2*center_->getSectionLength();
Index: code/branches/cpp11_v2/src/modules/jump/Jump.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/Jump.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/Jump.h	(revision 10817)
@@ -40,8 +40,8 @@
             Jump(Context* context);
             virtual ~Jump();
-            virtual void tick(float dt);
-            virtual void start();
-            virtual void end();
-            virtual void spawnPlayer(PlayerInfo* player);
+            virtual void tick(float dt) override;
+            virtual void start() override;
+            virtual void end() override;
+            virtual void spawnPlayer(PlayerInfo* player) override;
             int getScore(PlayerInfo* player) const;
             float getFuel() const;
Index: code/branches/cpp11_v2/src/modules/jump/JumpBoots.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpBoots.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpBoots.h	(revision 10817)
@@ -40,7 +40,7 @@
             JumpBoots(Context* context);
             virtual ~JumpBoots();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            virtual void touchFigure();
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+            virtual void touchFigure() override;
             virtual float getFuelState();
         protected:
Index: code/branches/cpp11_v2/src/modules/jump/JumpCenterpoint.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpCenterpoint.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpCenterpoint.h	(revision 10817)
@@ -108,5 +108,5 @@
             JumpCenterpoint(Context* context); //!< Constructor. Registers and initializes the object and checks whether the gametype is actually Jump.
             virtual ~JumpCenterpoint() {}
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method to create a JumpCenterpoint through XML.
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override; //!< Method to create a JumpCenterpoint through XML.
             void setPlatformStaticTemplate(const std::string& balltemplate)
                 { this->platformStaticTemplate_ = balltemplate; }
Index: code/branches/cpp11_v2/src/modules/jump/JumpEnemy.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpEnemy.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpEnemy.h	(revision 10817)
@@ -46,6 +46,6 @@
             JumpEnemy(Context* context);
             virtual ~JumpEnemy();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
             void setFieldDimension(float width, float height)
                 { this->fieldWidth_ = width; this->fieldHeight_ = height; }
Index: code/branches/cpp11_v2/src/modules/jump/JumpFigure.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpFigure.cc	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpFigure.cc	(revision 10817)
@@ -319,5 +319,5 @@
     bool JumpFigure::StartShield(JumpShield* shield)
     {
-        if (shieldActive_ == false)
+        if (shieldActive_ == nullptr)
         {
             attach(shield);
Index: code/branches/cpp11_v2/src/modules/jump/JumpFigure.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpFigure.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpFigure.h	(revision 10817)
@@ -40,13 +40,13 @@
             JumpFigure(Context* context); //!< Constructor. Registers and initializes the object.
             virtual ~JumpFigure() {}
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            virtual void tick(float dt);
-            virtual void moveFrontBack(const Vector2& value); //!< Overloaded the function to steer the bat up and down.
-            virtual void moveRightLeft(const Vector2& value); //!< Overloaded the function to steer the bat up and down.
-            virtual void rotateYaw(const Vector2& value);
-            virtual void rotatePitch(const Vector2& value);
-            virtual void rotateRoll(const Vector2& value);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+            virtual void tick(float dt) override;
+            virtual void moveFrontBack(const Vector2& value) override; //!< Overloaded the function to steer the bat up and down.
+            virtual void moveRightLeft(const Vector2& value) override; //!< Overloaded the function to steer the bat up and down.
+            virtual void rotateYaw(const Vector2& value) override;
+            virtual void rotatePitch(const Vector2& value) override;
+            virtual void rotateRoll(const Vector2& value) override;
             void fire(unsigned int firemode);
-            virtual void fired(unsigned int firemode);
+            virtual void fired(unsigned int firemode) override;
             virtual void JumpFromPlatform(JumpPlatform* platform);
             virtual void JumpFromSpring(JumpSpring* spring);
Index: code/branches/cpp11_v2/src/modules/jump/JumpItem.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpItem.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpItem.h	(revision 10817)
@@ -47,6 +47,6 @@
             JumpItem(Context* context);
             virtual ~JumpItem();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
             virtual void setProperties(float newLeftBoundary, float newRightBoundary, float newLowerBoundary, float newUpperBoundary, float newHSpeed, float newVSpeed);
             virtual void setFigure(JumpFigure* newFigure);
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatform.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatform.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatform.h	(revision 10817)
@@ -46,6 +46,6 @@
             JumpPlatform(Context* context);
             virtual ~JumpPlatform();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
             void setFigure(JumpFigure* newFigure);
             virtual void touchFigure();
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformDisappear.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformDisappear.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformDisappear.h	(revision 10817)
@@ -46,9 +46,9 @@
             JumpPlatformDisappear(Context* context);
             virtual ~JumpPlatformDisappear();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
             virtual void setProperties(bool active);
             virtual bool isActive();
-            virtual void touchFigure();
+            virtual void touchFigure() override;
 
         protected:
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformFake.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformFake.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformFake.h	(revision 10817)
@@ -46,6 +46,6 @@
             JumpPlatformFake(Context* context);
             virtual ~JumpPlatformFake();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
     };
 }
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformHMove.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformHMove.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformHMove.h	(revision 10817)
@@ -41,8 +41,8 @@
             JumpPlatformHMove(Context* context);
             virtual ~JumpPlatformHMove();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
             virtual void setProperties(float leftBoundary, float rightBoundary, float speed);
-            virtual void touchFigure();
+            virtual void touchFigure() override;
 
         protected:
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformStatic.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformStatic.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformStatic.h	(revision 10817)
@@ -41,8 +41,8 @@
             virtual ~JumpPlatformStatic();
 
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
 
-            virtual void touchFigure();
+            virtual void touchFigure() override;
     };
 }
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformTimer.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformTimer.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformTimer.h	(revision 10817)
@@ -46,9 +46,9 @@
             JumpPlatformTimer(Context* context);
             virtual ~JumpPlatformTimer();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
             virtual void setProperties(float time);
             virtual bool isActive(void);
-            virtual void touchFigure();
+            virtual void touchFigure() override;
 
             void setEffectPath(const std::string& effectPath)
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformVMove.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformVMove.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformVMove.h	(revision 10817)
@@ -40,8 +40,8 @@
             JumpPlatformVMove(Context* context);
             virtual ~JumpPlatformVMove();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
             virtual void setProperties(float leftBoundary, float rightBoundary, float speed);
-            virtual void touchFigure();
+            virtual void touchFigure() override;
 
         protected:
Index: code/branches/cpp11_v2/src/modules/jump/JumpProjectile.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpProjectile.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpProjectile.h	(revision 10817)
@@ -43,7 +43,7 @@
             virtual ~JumpProjectile();
 
-            virtual void tick(float dt);
+            virtual void tick(float dt) override;
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
 
             void setFieldDimension(float width, float height)
Index: code/branches/cpp11_v2/src/modules/jump/JumpPropeller.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPropeller.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPropeller.h	(revision 10817)
@@ -40,7 +40,7 @@
             JumpPropeller(Context* context);
             virtual ~JumpPropeller();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            virtual void touchFigure();
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+            virtual void touchFigure() override;
             virtual float getFuelState();
         protected:
Index: code/branches/cpp11_v2/src/modules/jump/JumpRocket.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpRocket.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpRocket.h	(revision 10817)
@@ -40,7 +40,7 @@
             JumpRocket(Context* context);
             virtual ~JumpRocket();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            virtual void touchFigure();
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+            virtual void touchFigure() override;
             virtual float getFuelState();
         protected:
Index: code/branches/cpp11_v2/src/modules/jump/JumpScore.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpScore.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpScore.h	(revision 10817)
@@ -44,7 +44,7 @@
             virtual ~JumpScore();
 
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            virtual void changedOwner();
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+            virtual void changedOwner() override;
 
             void setShowScore(const bool showScore)
Index: code/branches/cpp11_v2/src/modules/jump/JumpShield.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpShield.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpShield.h	(revision 10817)
@@ -40,7 +40,7 @@
             JumpShield(Context* context);
             virtual ~JumpShield();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            virtual void touchFigure();
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+            virtual void touchFigure() override;
             virtual float getFuelState();
         protected:
Index: code/branches/cpp11_v2/src/modules/jump/JumpSpring.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpSpring.h	(revision 10768)
+++ code/branches/cpp11_v2/src/modules/jump/JumpSpring.h	(revision 10817)
@@ -40,8 +40,8 @@
             JumpSpring(Context* context);
             virtual ~JumpSpring();
-            virtual void tick(float dt);
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void tick(float dt) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
             virtual void accelerateFigure();
-            virtual void touchFigure();
+            virtual void touchFigure() override;
         protected:
             float stretch_;